CREATE DATABASE [pubs] COLLATE SQL_Latin1_General_CP1_CI_AS
GO
RAISERROR(N'Create Stored Procedure [dbo].[byroyalty]', 0, 1) WITH NOWAIT;
GO
CREATE PROCEDURE [dbo].[byroyalty]
@percentage INT
WITH EXECUTE AS CALLER
AS
select au_id from titleauthor
where titleauthor.royaltyper = @percentage


GO
RAISERROR(N'Create Stored Procedure [dbo].[reptq3]', 0, 1) WITH NOWAIT;
GO
CREATE PROCEDURE [dbo].[reptq3]
@lolimit MONEY, @hilimit MONEY, @type CHAR (12)
WITH EXECUTE AS CALLER
AS
select pub_id, type, title_id, price
from titles
where price >@lolimit AND price <@hilimit AND type = @type OR type LIKE '%cook%'
order by pub_id, type
COMPUTE count(title_id) BY pub_id, type


GO
RAISERROR(N'Create Stored Procedure [dbo].[reptq2]', 0, 1) WITH NOWAIT;
GO
CREATE PROCEDURE [dbo].[reptq2]

WITH EXECUTE AS CALLER
AS
select type, pub_id, titles.title_id, au_ord,
   Name = substring (au_lname, 1,15), ytd_sales
from titles, authors, titleauthor
where titles.title_id = titleauthor.title_id AND authors.au_id = titleauthor.au_id
   AND pub_id is NOT NULL
order by pub_id, type
COMPUTE avg(ytd_sales) BY pub_id, type
COMPUTE avg(ytd_sales) BY pub_id


GO
RAISERROR(N'Create Stored Procedure [dbo].[reptq1]', 0, 1) WITH NOWAIT;
GO
CREATE PROCEDURE [dbo].[reptq1]

WITH EXECUTE AS CALLER
AS
select pub_id, title_id, price, pubdate
from titles
where price is NOT NULL
order by pub_id
COMPUTE avg(price) BY pub_id
COMPUTE avg(price)


GO
RAISERROR(N'Create Table [dbo].[sales]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[sales] (
    [stor_id]  CHAR (4)     COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [ord_num]  VARCHAR (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [ord_date] DATETIME     NOT NULL,
    [qty]      SMALLINT     NOT NULL,
    [payterms] VARCHAR (12) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [title_id] [dbo].[tid]  NOT NULL,
    CONSTRAINT [UPKCL_sales] PRIMARY KEY CLUSTERED ([stor_id], [ord_num], [title_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF),
    CONSTRAINT [FK__sales__title_id__145C0A3F] FOREIGN KEY ([title_id]) REFERENCES [dbo].[titles] ([title_id]) ON DELETE NO ACTION ON UPDATE NO ACTION,
    CONSTRAINT [FK__sales__stor_id__1367E606] FOREIGN KEY ([stor_id]) REFERENCES [dbo].[stores] ([stor_id]) ON DELETE NO ACTION ON UPDATE NO ACTION
)
GO
RAISERROR(N'Create Table [dbo].[publishers]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[publishers] (
    [pub_id]   CHAR (4)     COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [pub_name] VARCHAR (40) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [city]     VARCHAR (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [state]    CHAR (2)     COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [country]  VARCHAR (30) COLLATE SQL_Latin1_General_CP1_CI_AS CONSTRAINT [DF__publisher__count__060DEAE8] DEFAULT ('USA') NULL,
    CONSTRAINT [UPKCL_pubind] PRIMARY KEY CLUSTERED ([pub_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF),
    CONSTRAINT [CK__publisher__pub_i__0519C6AF] CHECK (([pub_id]='1756' OR [pub_id]='1622' OR [pub_id]='0877' OR [pub_id]='0736' OR [pub_id]='1389' OR [pub_id] like '99[0-9][0-9]'))
)
GO
RAISERROR(N'Create Table [dbo].[employee]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[employee] (
    [emp_id]    [dbo].[empid] NOT NULL,
    [fname]     VARCHAR (20)  COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [minit]     CHAR (1)      COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [lname]     VARCHAR (30)  COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [job_id]    SMALLINT      CONSTRAINT [DF__employee__job_id__25869641] DEFAULT ((1)) NOT NULL,
    [job_lvl]   TINYINT       CONSTRAINT [DF__employee__job_lv__276EDEB3] DEFAULT ((10)) NULL,
    [pub_id]    CHAR (4)      COLLATE SQL_Latin1_General_CP1_CI_AS CONSTRAINT [DF__employee__pub_id__286302EC] DEFAULT ('9952') NOT NULL,
    [hire_date] DATETIME      CONSTRAINT [DF__employee__hire_d__2A4B4B5E] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT [PK_emp_id] PRIMARY KEY NONCLUSTERED ([emp_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF),
    CONSTRAINT [FK__employee__job_id__267ABA7A] FOREIGN KEY ([job_id]) REFERENCES [dbo].[jobs] ([job_id]) ON DELETE NO ACTION ON UPDATE NO ACTION,
    CONSTRAINT [CK_emp_id] CHECK (([emp_id] like '[A-Z][A-Z][A-Z][1-9][0-9][0-9][0-9][0-9][FM]' OR [emp_id] like '[A-Z]-[A-Z][1-9][0-9][0-9][0-9][0-9][FM]')),
    CONSTRAINT [FK__employee__pub_id__29572725] FOREIGN KEY ([pub_id]) REFERENCES [dbo].[publishers] ([pub_id]) ON DELETE NO ACTION ON UPDATE NO ACTION
)
GO
RAISERROR(N'Create Table [dbo].[pub_info]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[pub_info] (
    [pub_id]  CHAR (4) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [logo]    IMAGE    NULL,
    [pr_info] TEXT     COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    CONSTRAINT [UPKCL_pubinfo] PRIMARY KEY CLUSTERED ([pub_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF),
    CONSTRAINT [FK__pub_info__pub_id__21B6055D] FOREIGN KEY ([pub_id]) REFERENCES [dbo].[publishers] ([pub_id]) ON DELETE NO ACTION ON UPDATE NO ACTION
)
GO
RAISERROR(N'Create Table [dbo].[stores]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[stores] (
    [stor_id]      CHAR (4)     COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [stor_name]    VARCHAR (40) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [stor_address] VARCHAR (40) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [city]         VARCHAR (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [state]        CHAR (2)     COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [zip]          CHAR (5)     COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    CONSTRAINT [UPK_storeid] PRIMARY KEY CLUSTERED ([stor_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF)
)
GO
RAISERROR(N'Create Table [dbo].[discounts]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[discounts] (
    [discounttype] VARCHAR (40)   COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [stor_id]      CHAR (4)       COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [lowqty]       SMALLINT       NULL,
    [highqty]      SMALLINT       NULL,
    [discount]     DECIMAL (4, 2) NOT NULL,
    CONSTRAINT [FK__discounts__stor___182C9B23] FOREIGN KEY ([stor_id]) REFERENCES [dbo].[stores] ([stor_id]) ON DELETE NO ACTION ON UPDATE NO ACTION
)
GO
RAISERROR(N'Create Table [dbo].[titleauthor]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[titleauthor] (
    [au_id]      [dbo].[id]  NOT NULL,
    [title_id]   [dbo].[tid] NOT NULL,
    [au_ord]     TINYINT     NULL,
    [royaltyper] INT         NULL,
    CONSTRAINT [FK__titleauth__au_id__0DAF0CB0] FOREIGN KEY ([au_id]) REFERENCES [dbo].[authors] ([au_id]) ON DELETE NO ACTION ON UPDATE NO ACTION,
    CONSTRAINT [FK__titleauth__title__0EA330E9] FOREIGN KEY ([title_id]) REFERENCES [dbo].[titles] ([title_id]) ON DELETE NO ACTION ON UPDATE NO ACTION,
    CONSTRAINT [UPKCL_taind] PRIMARY KEY CLUSTERED ([au_id], [title_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF)
)
GO
RAISERROR(N'Create Index [dbo].[titleauthor].[titleidind]', 0, 1) WITH NOWAIT;
GO
CREATE NONCLUSTERED INDEX [titleidind]
    ON [dbo].[titleauthor]([title_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, ONLINE = OFF, SORT_IN_TEMPDB = OFF)
GO
RAISERROR(N'Create Index [dbo].[titleauthor].[auidind]', 0, 1) WITH NOWAIT;
GO
CREATE NONCLUSTERED INDEX [auidind]
    ON [dbo].[titleauthor]([au_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, ONLINE = OFF, SORT_IN_TEMPDB = OFF)
GO
RAISERROR(N'Create Table [dbo].[authors]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[authors] (
    [au_id]    [dbo].[id]   NOT NULL,
    [au_lname] VARCHAR (40) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [au_fname] VARCHAR (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [phone]    CHAR (12)    COLLATE SQL_Latin1_General_CP1_CI_AS CONSTRAINT [DF__authors__phone__014935CB] DEFAULT ('UNKNOWN') NOT NULL,
    [address]  VARCHAR (40) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [city]     VARCHAR (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [state]    CHAR (2)     COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [zip]      CHAR (5)     COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [contract] BIT          NOT NULL,
    CONSTRAINT [CK__authors__au_id__00551192] CHECK (([au_id] like '[0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9][0-9][0-9]')),
    CONSTRAINT [CK__authors__zip__023D5A04] CHECK (([zip] like '[0-9][0-9][0-9][0-9][0-9]')),
    CONSTRAINT [UPKCL_auidind] PRIMARY KEY CLUSTERED ([au_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF)
)
GO
RAISERROR(N'Create Table [dbo].[roysched]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[roysched] (
    [title_id] [dbo].[tid] NOT NULL,
    [lorange]  INT         NULL,
    [hirange]  INT         NULL,
    [royalty]  INT         NULL,
    CONSTRAINT [FK__roysched__title___164452B1] FOREIGN KEY ([title_id]) REFERENCES [dbo].[titles] ([title_id]) ON DELETE NO ACTION ON UPDATE NO ACTION
)
GO
RAISERROR(N'Create Index [dbo].[roysched].[titleidind]', 0, 1) WITH NOWAIT;
GO
CREATE NONCLUSTERED INDEX [titleidind]
    ON [dbo].[roysched]([title_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, ONLINE = OFF, SORT_IN_TEMPDB = OFF)
GO
RAISERROR(N'Create Table [dbo].[jobs]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[jobs] (
    [job_id]   SMALLINT     IDENTITY (1, 1) NOT NULL,
    [job_desc] VARCHAR (50) COLLATE SQL_Latin1_General_CP1_CI_AS CONSTRAINT [DF__jobs__job_desc__1CF15040] DEFAULT ('New Position - title not formalized yet') NOT NULL,
    [min_lvl]  TINYINT      NOT NULL,
    [max_lvl]  TINYINT      NOT NULL,
    CONSTRAINT [CK__jobs__max_lvl__1ED998B2] CHECK (([max_lvl]<=(250))),
    CONSTRAINT [CK__jobs__min_lvl__1DE57479] CHECK (([min_lvl]>=(10))),
    CONSTRAINT [PK__jobs__6E32B6A51B0907CE] PRIMARY KEY CLUSTERED ([job_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF)
)
GO
RAISERROR(N'Create Index [dbo].[titles].[titleind]', 0, 1) WITH NOWAIT;
GO
CREATE NONCLUSTERED INDEX [titleind]
    ON [dbo].[titles]([title]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, ONLINE = OFF, SORT_IN_TEMPDB = OFF)
GO
RAISERROR(N'Create Table [dbo].[titles]', 0, 1) WITH NOWAIT;
GO
CREATE TABLE [dbo].[titles] (
    [title_id]  [dbo].[tid]   NOT NULL,
    [title]     VARCHAR (80)  COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    [type]      CHAR (12)     COLLATE SQL_Latin1_General_CP1_CI_AS CONSTRAINT [DF__titles__type__08EA5793] DEFAULT ('UNDECIDED') NOT NULL,
    [pub_id]    CHAR (4)      COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [price]     MONEY         NULL,
    [advance]   MONEY         NULL,
    [royalty]   INT           NULL,
    [ytd_sales] INT           NULL,
    [notes]     VARCHAR (200) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [pubdate]   DATETIME      CONSTRAINT [DF__titles__pubdate__0AD2A005] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT [UPKCL_titleidind] PRIMARY KEY CLUSTERED ([title_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF),
    CONSTRAINT [FK__titles__pub_id__09DE7BCC] FOREIGN KEY ([pub_id]) REFERENCES [dbo].[publishers] ([pub_id]) ON DELETE NO ACTION ON UPDATE NO ACTION
)
GO
RAISERROR(N'Create UserDefinedDataType [dbo].[empid]', 0, 1) WITH NOWAIT;
GO
CREATE TYPE [dbo].[empid]
    FROM CHAR (9) NOT NULL
GO
RAISERROR(N'Create UserDefinedDataType [dbo].[tid]', 0, 1) WITH NOWAIT;
GO
CREATE TYPE [dbo].[tid]
    FROM VARCHAR (6) NOT NULL
GO
RAISERROR(N'Create UserDefinedDataType [dbo].[id]', 0, 1) WITH NOWAIT;
GO
CREATE TYPE [dbo].[id]
    FROM VARCHAR (11) NOT NULL
GO
RAISERROR(N'Create View [dbo].[titleview]', 0, 1) WITH NOWAIT;
GO
CREATE VIEW [dbo].[titleview]
AS
select title, au_ord, au_lname, price, ytd_sales, pub_id
from authors, titles, titleauthor
where authors.au_id = titleauthor.au_id
   AND titles.title_id = titleauthor.title_id
GO
RAISERROR(N'Create Index [dbo].[sales].[titleidind]', 0, 1) WITH NOWAIT;
GO
CREATE NONCLUSTERED INDEX [titleidind]
    ON [dbo].[sales]([title_id]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, ONLINE = OFF, SORT_IN_TEMPDB = OFF)
GO
RAISERROR(N'Create Index [dbo].[employee].[employee_ind]', 0, 1) WITH NOWAIT;
GO
CREATE CLUSTERED INDEX [employee_ind]
    ON [dbo].[employee]([lname], [fname], [minit]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, ONLINE = OFF, SORT_IN_TEMPDB = OFF)
GO
RAISERROR(N'Create Trigger [dbo].[employee].[employee_insupd]', 0, 1) WITH NOWAIT;
GO
CREATE TRIGGER [dbo].[employee_insupd]
    ON [dbo].[employee]
    WITH EXECUTE AS CALLER
    AFTER INSERT, UPDATE
    AS --Get the range of level for this job type from the jobs table.
declare @min_lvl tinyint,
   @max_lvl tinyint,
   @emp_lvl tinyint,
   @job_id smallint
select @min_lvl = min_lvl,
   @max_lvl = max_lvl,
   @emp_lvl = i.job_lvl,
   @job_id = i.job_id
from employee e, jobs j, inserted i
where e.emp_id = i.emp_id AND i.job_id = j.job_id
IF (@job_id = 1) and (@emp_lvl <> 10)
begin
   raiserror ('Job id 1 expects the default level of 10.',16,1)
   ROLLBACK TRANSACTION
end
ELSE
IF NOT (@emp_lvl BETWEEN @min_lvl AND @max_lvl)
begin
   raiserror ('The level for job_id:%d should be between %d and %d.',
      16, 1, @job_id, @min_lvl, @max_lvl)
   ROLLBACK TRANSACTION
end


GO
RAISERROR(N'Create Index [dbo].[authors].[aunmind]', 0, 1) WITH NOWAIT;
GO
CREATE NONCLUSTERED INDEX [aunmind]
    ON [dbo].[authors]([au_lname], [au_fname]) WITH (IGNORE_DUP_KEY = OFF, ALLOW_PAGE_LOCKS = ON, ALLOW_ROW_LOCKS = ON, PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, ONLINE = OFF, SORT_IN_TEMPDB = OFF)
GO
